<?
/*
CMSimple sBlog plugin version 0.1 beta 8
by http://www.nmud.de/
is a substantial modification of the CMSimple Guestbook plugin (gbook version 0.1 beta2)
made by http://www.qualifire.de/cmsimple/.
Since sBlog is made for CMSimple and runs only under CMSimple's environment,
this plugin is subject to the AGPL conditions - like CMSimple itself.
Informations about the AGPL-conditions can be found at http://www.cmsimple.dk/?License.

version 0.1 beta 1 (release: 1.4.2006)
Features:
 - display of email and website of visitor with on/off toggle.
 - comments in chronological or reverse chronological order.
 - simple Captcha function with on/off toggle.
 - cleanText function with on/off toggle.
 - email notice function.
 - control of mandatory fields.
 - German and English language packs.

version 0.1 beta 2 (release: 26.4.2006)
Changes:
 - comment editor is now placed at the bottom, if comments are shown in chronological order. It is placed at the top, if comments are shown in reverse chronological order.
 - The simple Captcha function alerts if a wrong number code has been typed in.
 - Addition of French, Norwegian, and Danish language packs.

version 0.1 beta 3 (release: 26.4.2006)
Changes:
 - one image per message can be shown by adding an image's web address. Warning: New text file structure!!!
 - image max size (width/height) can be adjusted.
 - images can be viewed in their original size by clicking on the individual image (like in Michael Svarrer's gallery plugin).
 - sBlog is more userfriendly now. Each CSS property is explained what's its job is.

 version 0.1 beta 4 (release: 4.5.2006)
 Changes:
 - new deletion function in the admin modul. Files can be deleted now without contact via FTP. However, the deletion of files is irrevocable; there is no alert function to warn you.
 - the CSS div#sblog property bug has been fixed (already done in version 0.1 beta 3 build 8). Depending on choosing the chronology option, it moved around. This is fixed now.
 - HTML Tidy alerts have been polished (already done in version 0.1 beta 3 build 8). 
 - the minmax.js file is only read in, if allow_url_fopen=off and only by IE (due to conditional comment, already done in version 0.1 beta 3 build 8). 
 - some minor bug fixes (already done in version 0.1 beta 3 build 8).

 version 0.1 beta 5 (release: 17.5.2006)
 Fix:
 - just one important fix has been undertaken. In version 0.1 beta 4, the deletion function worked only in Firefox and other Gecko browsers. It did not run in Internet Explorer. Beta 5 now does. Therefore, this version replaces beta 4.

version 0.1 beta 6 (release: 23.5.2006)
 Change:
 - an optional record release function has been built in. If it is set to "true" in the configurations, each record adds "##" to its first field. This has to be removed before it is shown in the output file.

 version 0.1 beta 7 (release: 12.11.2006)
 Change: variable mnu to menu: ready for CMSimple 2.7 

 version 0.1 beta 8 (release: 8.10.2007)
 Suppression of backslashes in front of single and double quotation marks.
*/
function sblog($sblogFile) {

	GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $sbfile, $vartl, $imgpath;
	$sbname = isset($_POST['sbname']) ? $_POST['sbname'] : $_GET['sbname'];
	$sbemail = isset($_POST['sbemail']) ? $_POST['sbemail'] : $_GET['sbemail'];
	$sbwebsite = isset($_POST['sbwebsite']) ? $_POST['sbwebsite'] : $_GET['sbwebsite'];
	$sbimage = isset($_POST['sbimage']) ? $_POST['sbimage'] : $_GET['sbimage'];
	$sbmessage = isset($_POST['sbmessage']) ? $_POST['sbmessage'] : $_GET['sbmessage'];
	$sbcc = $_POST['sbcc'];
	$rightnumber =$_POST['rightnumber'];
	$plugin=basename(dirname(__FILE__),"/");
	$sbfile = $pth['folder']['plugins'].$plugin."/content/".$sblogFile."_".$sl.".txt";
	$imgpath = $pth['folder']['plugins']."sblog/";
	if(eregi("true",$plugin_cf['sblog']['simpleCaptcha'])){
	$rightCaptcha = ($sbcc == $rightnumber);
		} else $rightCaptcha = "true"; 

	if($sbname && $sbmessage && ($rightCaptcha == "true")){

		$sbname = sb_cleantext($sbname);
	//	$sbemail = sb_cleantext($sbmail);
		$sbwebsite = sb_cleantext($sbwebsite);
		$sbimage = sb_cleantext($sbimage);
		$sbmessage = str_replace(chr(13).chr(10),"<br />",$sbmessage);
		$sbmessage = str_replace(chr(13),"<br />",$sbmessage);
		$sbmessage = str_replace(chr(10),"<br />",$sbmessage);
		$sbmessage = str_replace(";",",",$sbmessage);

		if(eregi("true",$plugin_cf['sblog']['cleanText'])){
		  $sbmessage = sb_cleantext(stripslashes($sbmessage));
		}
		if (!$fp = fopen($sbfile, 'a')) {
			$tvari.="<br />ERROR: Cannot open file ($sbfile)";
		} else {
			if(eregi("true",$plugin_cf['sblog']['record_Release'])){
				$sbentry = "\n##" . $sbname .";". $sbemail .";". $sbwebsite .";". date($plugin_cf['sblog']['time_format']) .";". date($plugin_cf['sblog']['date_format']) .";". $sbimage .";". $sbmessage .";". $_SERVER["REMOTE_ADDR"] . ";[END OF RECORD]";
			} else {
				$sbentry = "\n" . $sbname .";". $sbemail .";". $sbwebsite .";". date($plugin_cf['sblog']['time_format']) .";". date($plugin_cf['sblog']['date_format']) .";". $sbimage .";". $sbmessage .";". $_SERVER["REMOTE_ADDR"] . ";[END OF RECORD]";
			}
		

		if ($plugin_cf['sblog']['emailNotice'] !=="") {				
			////////////////////////////////////////////////////
			//Mailer: 
			//
			$kopf = $plugin_tx['sblog']['mail_header']." ".$page;
			$page = $_SERVER[QUERY_STRING];
			$ipbesucher = $_SERVER['REMOTE_ADDR'];
			$nachrichtanmich = "\n\n" . $kopf . " ".$plugin_tx['sblog']['mail_file']." \"".$page."\"\n\n"
			."*******************************************************\n"
//			." From: ".$kopf." ".$plugin_tx['sblog']['mail_file']." \"".$page."\"\n\n"
			." Text: \n".$sbmessage."\n\n  From IP: $ipbesucher \n\n"
			."*******************************************************\n"
			."";
			$webmaster=$plugin_cf['sblog']['emailNoticeTo'];
			$header ="FROM:CMSimple sBlog <$webmaster>\n";
			$header .="X-Mailer :PHP/" . phpversion()."\n";
			$header .="X-Sender-IP: " .$_SERVER['REMOTE_ADDR']. "\n";
			$header .="Content-Type: text/plain";
			mail ($webmaster, $kopf, $nachrichtanmich, $header);
			/////////////////////////////////////////////// 
		}		 
	 if (fputs($fp,$sbentry) == FALSE)
		$tvari.="<br />ERROR: Cannot write to file ($sbfile)";
	 fclose($fp);
	 
	 header('Location: '.$_SERVER['REQUEST_URI']);exit;
	}
	}

	$tvari .= "<div id=\"sblog\">\n"; // first DIV encompasses whole output with editor, closes at the bottom

///////  OUTPUT 1  /////////////////////
	if(eregi("true",$plugin_cf['sblog']['chronological_order'])){
		if(ini_get('allow_url_fopen') != 1){
		$vartl = "<!--[if IE]><script type=\"text/javascript\" src=\"./plugins/sblog/minmax.js\"></script><![endif]-->\n";
		}
		sb_commentOutput();
		$tvari .= stripslashes($vartl);
		$tvari .= "<br />";
//		$tvari .= "<p>&nbsp;</p>";
	}
/////////  End of OUTPUT 1 ////////////////////////
	$tvari .= "<script language = \"JavaScript\" type= \"text/javascript\">\n";
	$tvari .= "function sBlog_pic_fullsize(PIC_URL, width, height){\n";
	$tvari .= "popup_options=\"toolbar=0,scrollbars=0,location=0,statusbar=0,menubar=0,resizable=0\";\n";
	$tvari .= "gallery_popup=window.open(\"\", \"\", popup_options + \",width=\" + width + \",height=\" + height);\n";
	$tvari .= "gallery_popup.focus();gallery_popup.document.open();\n";
	$tvari .= "with(gallery_popup){\n";
	$tvari .= "document.write(\"<html><head>\");\n";
	$tvari .= "document.write(\"<title>Picture popup<\/title>\");\n";
	$tvari .= "document.write(\"<\/head>\");\n";
	$tvari .= "document.write(\"<body leftmargin=\\\"0\\\" marginheight=\\\"0\\\" marginwidth=\\\"0\\\" topmargin=\\\"0\\\">\");\n";
	$tvari .= "document.write(\"<img border=\\\"0\\\" onclick=\\\"window.close();\\\" src=\\\"\"+ PIC_URL +\"\\\" title=\\\"Close by clicking / Schlieen\\\" alt=\\\"Close by clicking / Schlieen\\\" />\");\n";
	$tvari .= "document.write(\"<\/body><\/html>\");}}\n";
	$tvari .="function checkFormField(){\n";
		if(eregi("true",$plugin_cf['sblog']['simpleCaptcha'])){
			$sbrandom=rand(100000,999999);
	$tvari .= "if(document.simpleBlog.sbcc.value == \"\") {alert(\"".$plugin_tx['sblog']['mustwritecaptcha']."\");document.simpleBlog.sbcc.focus();document.simpleBlog.sbcc.style.border='1px solid Red';return false;}\n";
	$tvari .= "if(document.simpleBlog.sbcc.value != \"".$sbrandom."\") {alert(\"".$plugin_tx['sblog']['wrongcaptcha']."\");document.simpleBlog.sbcc.focus();document.simpleBlog.sbcc.style.border='1px solid Red';return false;}\n";
		}
	$tvari .= "if(document.simpleBlog.sbname.value == \"\") {alert(\"".$plugin_tx['sblog']['mustwritename']."\");document.simpleBlog.sbname.focus();document.simpleBlog.sbname.style.border='1px solid Red';return false;}\n";
	$tvari .= "if(document.simpleBlog.sbmessage.value == \"\") {alert(\"".$plugin_tx['sblog']['mustwritemes']."\");document.simpleBlog.sbmessage.focus();document.simpleBlog.sbmessage.style.border='1px solid Red';return false;}\n";
	if(eregi("true",$plugin_cf['sblog']['record_Release'])) {
	$tvari .= "alert(\"".$plugin_tx['sblog']['record_release']."\")\n";
	}
	$tvari .="}\n";
	$tvari .= "</script>\n";
	$tvari .= "<script language = \"JavaScript\" type= \"text/javascript\">\n";
	$tvari .= "function showDetail(iNum)\n";
	$tvari .= "{\n";
	$tvari .= "var IDName;\n";
	$tvari .= "IDdetail = 'detail' + iNum;\n";
	$tvari .= "IDnewMessage = 'newMessage' + iNum;\n";
	$tvari .= "if (document.getElementById(IDdetail).style.display.indexOf('block') == -1) {\n";
	$tvari .= "document.getElementById(IDdetail).style.display = \"block\";\n";
	$tvari .= "document.getElementById(IDnewMessage).style.display = \"none\";\n";
	$tvari .= "} else {\n";
	$tvari .= "document.getElementById(IDdetail).style.display = \"none\";\n";
	$tvari .= "document.getElementById(IDnewMessage).style.display = \"block\";\n";
	$tvari .= "}\n";
	$tvari .= "}\n";
	$tvari .= "</script>\n";
	$tvari .= "<div id=\"editor\"><div id=\"newMessage1\"><a href=\"javascript:showDetail(1)\">".$plugin_tx['sblog']['txt_newentry'] . "</a><span id=\"noJavascript\"><noscript>" . $plugin_tx['sblog']['txt_nojscript'] . "</noscript></span></div>\n";
	$tvari .= "<div id=\"detail1\" style=\"display: none;\">\n";
	$tvari .= "<form name=\"simpleBlog\" method=\"post\" action=\"?".$su."\" onSubmit=\"return checkFormField()\">\n";
	if(eregi("true",$plugin_cf['sblog']['simpleCaptcha'])){
	$tvari.=$plugin_tx['sblog']['txt_simpleCaptcha'].":<span class=\"star\">*</span>&nbsp;".$sbrandom."<br /><input type=\"text\" name =\"sbcc\" size=\"7\" maxlength=\"6\" /><br />\n";
	$tvari.="<input type=\"hidden\" name=\"rightnumber\" value=\"".$sbrandom."\" />\n";
	}
	$tvari .= $plugin_tx['sblog']['txt_name'] . "<span class='star'>*</span>:<br />" . "<input name=\"sbname\" type=\"text\" size=\"40\" maxlength=\"80\" /><br />\n";
	if(eregi("true",$plugin_cf['sblog']['email'])){
	$tvari .= $plugin_tx['sblog']['txt_email'] . ":<br />" . "<input name=\"sbemail\" type=\"text\" size=\"40\" maxlength=\"80\" /><br />\n";}
	if(eregi("true",$plugin_cf['sblog']['website'])){
	$tvari .= $plugin_tx['sblog']['txt_website'] . ":<br />" . "<input name=\"sbwebsite\" type=\"text\" size=\"40\" maxlength=\"80\" />&nbsp;<br />\n";}
	if(eregi("true",$plugin_cf['sblog']['image'])){
	$tvari .= $plugin_tx['sblog']['txt_image'] . ":<br />" . "<input name=\"sbimage\" type=\"text\" size=\"40\" />&nbsp;<br /><div class=\"sbSmallText\">(e.g. www.myWebSite.com/images/myImage.jpg)</div>\n";}
	$tvari .= $plugin_tx['sblog']['txt_message'] . "<span class='star'>*</span>:<br />" . "<textarea rows=\"6\" cols=\"40\" name=\"sbmessage\"></textarea><br />\n";
	$tvari .= "<span class='star'>*&nbsp;</span>" . $plugin_tx['sblog']['txt_required'] . "<br />&nbsp;<br />\n";
	$tvari .= "<div id=\"inputsubmit\"><input type=\"submit\" value=\" " . $plugin_tx['sblog']['txt_submit'] . " \" />&nbsp;<input type=\"reset\" value=\" " . $plugin_tx['sblog']['txt_clear'] . " \" />&nbsp;<input type=\"button\" value=\" " . $plugin_tx['sblog']['hide_editor'] . "\" name=\"hide\" onClick=\"javascript:showDetail(1)\" /></div>\n";
	$tvari .= "</form>\n";
	$tvari .= "<br /></div></div>\n";
//	$tvari .= "&nbsp;<br />\n";

///////  OUTPUT 2  /////////////////////
	if(!eregi("true",$plugin_cf['sblog']['chronological_order'])){
		if(ini_get('allow_url_fopen') != 1){

		$vartIE = "<!--[if IE]><script type=\"text/javascript\" src=\"./plugins/sblog/minmax.js\"></script><![endif]-->\n";
		$tvari .= $vartIE;
		}
		sb_commentOutput();
		$tvari .= stripslashes($vartl);
		}
/////////  End of OUTPUT 2 ////////////////////////
	$tvari .= "</div>\n"; // closing of first DIV

   return $tvari;
}

function sb_cleantext($rawcode){
// This will remove HTML tags, javascript sections
// and white space. It will also convert some
// common HTML entities to their text equivalent
// Clever bits cut and pasted from php_manual_en.html#ref.pcre

$search = array ("'<script[^>]*?>.*?</script>'si", // Strip out javascript
"'<[\/\!]*?[^<>]*?>'si", // Strip out HTML tags
"'([\r\n])[\s]+'", // Strip out white space
"'&(quot|#34);'i", // Replace HTML entities
"'&(amp|#38);'i",
"'&(lt|#60);'i",
"'&(gt|#62);'i",
"'&(nbsp|#160);'i",
"'&(iexcl|#161);'i",
"'&(cent|#162);'i",
"'&(pound|#163);'i",
"'&(copy|#169);'i",
"'&#(\d+);'e"); // evaluate as php

$replace = array ("",
"",
"\\1",
"\"",
"&",
"<",
">",
" ",
chr(161),
chr(162),
chr(163),
chr(169),
"chr(\\1)");

$sb_cleantext = preg_replace($search, $replace, $rawcode); // delete ."cleaned" when tested
return $sb_cleantext;
}//end of sb_cleantext

function sb_commentOutput() {
	GLOBAL $sbfile, $vartl, $imgpath, $plugin_cf, $newwidth, $newheight, $width, $height;
	if(is_file($sbfile)){
	$fp = fopen($sbfile, "r");
	while (!feof($fp)) {
		  $line = fgets($fp, 4096);
		  if(substr($line,0,2) != '##'){
			  list($sbname,$sbemail,$sbwebsite,$sbtime,$sbdate,$sbimage,$sbmessage,$sbipaddr) = split( ";", $line);

			  $vartm = "";
			  if ($sbmessage != '') $vartm .= "<hr />\n";
			  if ($sbmessage != '') $vartm .= "<div class=\"sblogTable\"><table class=\"sblogTable\">\n";
			  if ($sbmessage != '') $vartm .= "<tr>\n";
			  if ($sbmessage != '') $vartm .= "<td class=\"nameBackground\" valign=\"top\"><span class=\"sbname\">" . $sbname . "</span>&nbsp;|&nbsp;\n";
			  if ($sbmessage != '') $vartm .= "<span class=\"sbdatetime\">" . $sbdate . ", " . $sbtime . "</span>&nbsp;|&nbsp;<span class=\"pics\">\n";
			  if ($sbemail != '') $vartm .= "<a href=\"mailto:" . $sbemail . "\"><img class=\"spic1\" src=\"".$imgpath."./images/email.gif\" border=\"0\" title=\"" . $sbemail . "\" alt=\"" . $sbemail . "\" /></a>&nbsp;\n";
			  if ($sbwebsite != '') $vartm .= "<a href=\"http://" . $sbwebsite . "\" target=\"_blank\"><img class=\"spic2\" src=\"".$imgpath."./images/website.gif\" border=\"0\" title=\"" . $sbwebsite . "\"  alt=\"" . $sbwebsite . "\" /></a>&nbsp;\n";
			  if ($sbmessage != '') $vartm .= "<img class=\"spic3\" src=\"".$imgpath."./images/machine.gif\" border=\"0\" title=\"" . $sbipaddr . " = " . gethostbyaddr($sbipaddr) . "\" alt=\"" . $sbipaddr . " = " . gethostbyaddr($sbipaddr) . "\" />\n";
			  if ($sbmessage != '') $vartm .= "</span></td></tr>\n";
			  if ($sbimage != ''){
				  makeImg($sbimage);
				  if(ini_get("allow_url_fopen") == 1) {
	//			  if ($newwidth != "" || $newheight != ""){
					  if (eregi("http://", $sbimage)){
					  $vartm .= "<tr><td class=\"imageBackground\" valign=\"top\">
					  <a href=\"javascript:sBlog_pic_fullsize('" . $sbimage ."','".$width."','".$height."')\"><img class=\"sBlogImage\" src=\"" . $sbimage . "\" width=\"" . $newwidth .  "\" height=\"" . $newheight .  "\" alt=\"" . $sbimage . "\" /></a></td></tr>\n";
					  } else {
						  $vartm .= "<tr><td class=\"imageBackground\" valign=\"top\">
						  <a href=\"javascript:sBlog_pic_fullsize('http://" . $sbimage ."','".$width."','".$height."')\"><img class=\"sBlogImage\" src=\"http://" . $sbimage . "\" width=\"" . $newwidth .  "\" height=\"" . $newheight .  "\" alt=\"" . $sbimage . "\" /></a></td></tr>\n";
						  }
				  } else { 
				// in case allow_url_fopen = off ---------------
					  if (eregi("http://", $sbimage)){

					  $vartm .= "<tr><td class=\"imageBackground\" valign=\"top\"><img class=\"sBlogImage\" src=\"" . $sbimage . "\" alt=\"" . $sbimage . "\" /></td></tr>\n";
					} else {
						  $vartm .= "<tr><td class=\"imageBackground\" valign=\"top\"><img class=\"sBlogImage\" src=\"http://" . $sbimage . "\" alt=\"" . $sbimage . "\" /></td></tr>\n";
						  }
					}
			  }
			  if ($sbmessage != '') $vartm .= "<tr><td class=\"messageBackground\" valign=\"top\"><span class=\"sbmessage\">" . $sbmessage . "&nbsp;</span></td>\n";
			  if ($sbmessage != '') $vartm .= "</tr>\n";
			  if ($sbmessage != '') $vartm .= "</table></div>\n";
			  if(eregi("true",$plugin_cf['sblog']['chronological_order'])){
				  $vartl = $vartl . $vartm;
				  } else {
					  $vartl = $vartm . $vartl;
						}
		  } // end of - if(substr($line,0,2) != '##') -
	}
	return $vartl;
	fclose($fp);
   }
}//end of sb_commentOutput

function makeImg($sbimage) { // resizing of images
	global $hmax, $wmax, $plugin_cf, $newwidth, $newheight, $width, $height; // max width and height, max new width and new height
	
if (eregi("http:",$sbimage)) {
	list($width, $height, $type, $attr) = getimagesize($sbimage);
} else {
	list($width, $height, $type, $attr) = getimagesize("http://" . $sbimage);
}
$hmax = $plugin_cf['sblog']['max_height'];
$wmax = $plugin_cf['sblog']['max_width'];
$hscale = $height / $hmax;
$wscale = $width / $wmax;
if (($hscale > 1) || ($wscale > 1)) {
	$scale = ($hscale > $wscale)?$hscale:$wscale;
	} else {
		$scale = 1;
		}
$newwidth = floor($width / $scale);
$newheight= floor($height / $scale);
if ($newwidth == "0") $newwidth = "";
if ($newheight == "0") $newheight = "";
return $newwidth;
return $newheight;
return $width;
return $height;
}

?>